using System;
using System.Collections.Generic;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;

namespace GGC
{
    public partial class Form1 : Form
    {
        //private System.ComponentModel.IContainer components = null;
        private  BindingList<CustomClass> bl;
        GridConditionalFormatDescriptor blinkDescriptor = new GridConditionalFormatDescriptor("BLINK");
        Hashtable hashTable = new Hashtable(); 
        public Form1()
        {
            InitializeComponent();
            OptimizeGridSettings(gidGroupingControl1);
            

            bl = new BindingList<CustomClass>();
            GridEvents();
            GridSorting();
        }

        //private void gridGroupingControl1_TableControlCellClick(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventArgs e)
        //{

        //}

        private void Form1_Load(object sender, EventArgs e)
        {
            this.gidGroupingControl1.GridVisualStyles = Syncfusion.Windows.Forms.GridVisualStyles.Office2007Blue;   
           
            bl.Add(new CustomClass(0101, "Charlotte", "Cooper", "49 Gilbert St.", "London",1,1,1,1,1,1,1,1));
            bl.Add(new CustomClass(0101, "Shelley", "Burke", "P.O. Box 78934", "New Orleans", 1, 1, 1, 1, 1, 1, 1, 1));
            bl.Add(new CustomClass(0101, "Regina", "Murphy", "707 Oxford Rd.", "Ann Arbor", 1, 1, 1, 1, 1, 1, 1, 1));
            bl.Add(new CustomClass(0102, "Yoshi", "Nagase", "9-8 Sekimai Musashino-shi", "Tokyo", 1, 1, 1, 1, 1, 1, 1, 1));
            bl.Add(new CustomClass(0102, "Mayumi", "Ohno", "Calle del Rosal 4", "Oviedo", 1, 1, 1, 1, 1, 1, 1, 1));
            bl.Add(new CustomClass(0102, "Ian", "Devling", "92 Setsuko Chuo-ku", "Osaka", 1, 1, 1, 1, 1, 1, 1, 1));
            bl.Add(new CustomClass(0103, "Peter", "Wilson", "74 Rose St. Moonie Ponds", "Melbourne", 1, 1, 1, 1, 1, 1, 1, 1));
            bl.Add(new CustomClass(0103, "Lars", "Peterson", "29 King's Way", "Manchester", 1, 1, 1, 1, 1, 1, 1, 1));
            bl.Add(new CustomClass(0103, "Carlos", "Diaz", "Kaloadagatan 13", "Goteborg", 1, 1, 1, 1, 1, 1, 1, 1));
            bl.Add(new CustomClass(0104, "Petra", "Winkler", "Av. das Americanas 12.890", "Sao Paulo", 1, 1, 1, 1, 1, 1, 1, 1));
            bl.Add(new CustomClass(0104, "Martin", "Bein", "Tiergartenstrae 5", "Berlin", 1, 1, 1, 1, 1, 1, 1, 1));
            bl.Add(new CustomClass(0104, "Sven", "Petersen", "Bogenallee 51", "Frankfurt", 1, 1, 1, 1, 1, 1, 1, 1));
           // System.Drawing.Icon ico = new System.Drawing.Icon(Syncfusion.Windows.Forms.WinFormsUtils.FindFile("Icon", "sfgrid.ico"));
            //this.Icon = ico;
            this.gidGroupingControl1.DataSource = bl;
            this.gidGroupingControl1.TableOptions.GridVisualStyles = Syncfusion.Windows.Forms.GridVisualStyles.Office2007Blue;
            this.gidGroupingControl1.TableOptions.GridLineBorder = new Syncfusion.Windows.Forms.Grid.GridBorder(GridBorderStyle.Solid, Color.FromArgb(208, 215, 229), GridBorderWeight.Thin);
            this.gidGroupingControl1.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
            this.gidGroupingControl1.TopLevelGroupOptions.ShowCaption = false;
            this.gidGroupingControl1.TableModel.TableStyle.Font.Facename = "Verdana";
            this.gidGroupingControl1.TableModel.TableStyle.TextColor = Color.MidnightBlue;
            this.BackColor = Color.FromArgb(223, 227, 239);

            
        }
        private void setUpTimer()
        {
            timer = new Timer();
            timer.Tick += new EventHandler(timer_Tick);
            timer.Interval = 1000;
            gidGroupingControl1.TableDescriptor.ConditionalFormats.Clear();
            timer.Start();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (timer == null)
                setUpTimer();
            timer.Enabled = true;
            if (hashTable.ContainsKey(textBox1.Text.ToString()))
            {

                MessageBox.Show("Value Already exit");
            }
            else
            {
                hashTable.Add(textBox1.Text, "false");
            }
            textBox1.Text = ""; 
 
        }

        private void timer_Tick(object sender, EventArgs e)
        {
            timer.Stop();
            string AID = "";
            
            
            foreach (Object key in hashTable.Keys)
            {
                if (AID.Length > 1) AID += " Or ";
                AID += "[ID]Like '" + (string)key + "'";
               
            }
            if (blinkDescriptor.Appearance.AnyCell.BackColor == Color.LightCoral)
            {
                blinkDescriptor.ResetAppearance();
            }
            else
            {
                blinkDescriptor.Appearance.AnyCell.BackColor = Color.LightCoral;
                
            }
            blinkDescriptor.Expression = AID;
            blinkDescriptor.ResetCompiledExpression();
            if (!gidGroupingControl1.TableDescriptor.ConditionalFormats.Contains("BLINK"))
                gidGroupingControl1.TableDescriptor.ConditionalFormats.Add(blinkDescriptor);

            timer.Start();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (timer == null)
                setUpTimer(); 
            timer.Stop();
            if (hashTable.ContainsKey(textBox2.Text.ToString()))
            {
                hashTable.Remove(textBox2.Text.ToString());
                gidGroupingControl1.Appearance.AnyCell.BackColor = Color.White;
            }
            else
            {
                MessageBox.Show("VALUE DOES NOT EXIT");
            }
            timer.Start();
            textBox2.Text = "";
        }
        private void OptimizeGridSettings(GridGroupingControl grid)
        {
            try
            {
                grid.CounterLogic = EngineCounters.YAmount;
                grid.AllowedOptimizations = EngineOptimizations.DisableCounters | EngineOptimizations.RecordsAsDisplayElements;
                grid.UseDefaultsForFasterDrawing = true; // GDI interop drawing, FirstNRecords Summaries
                grid.InvalidateAllWhenListChanged = false; // only paint modified cells 
                grid.InsertRemoveBehavior = GridListChangedInsertRemoveBehavior.ScrollWithImmediateUpdate;
                grid.UpdateDisplayFrequency = 50; // update every number of ms (speciy 0 if Update should occur manually, 1 if immediately)
                grid.BlinkTime = 700;
                // Instruct grouping control not to access datasource through
                // CurrencyManager API and instead access list diretly. When set to
                // false you wil howver loose support for built-in CurrencyManager 
                // synchronization.


                grid.TableOptions.ListBoxSelectionCurrentCellOptions = Syncfusion.Windows.Forms.Grid.Grouping.GridListBoxSelectionCurrentCellOptions.HideCurrentCell;
                grid.TableOptions.ListBoxSelectionColorOptions = Syncfusion.Windows.Forms.Grid.Grouping.GridListBoxSelectionColorOptions.ApplySelectionColor;
                grid.TableOptions.SelectionBackColor = Color.LightSteelBlue;
                grid.TableOptions.SelectionTextColor = Color.Black;


                grid.BindToCurrencyManager = false;
                if (typeof(object).AssemblyQualifiedName.IndexOf("Version=1") == -1)
                {
                    grid.AllowSwapDataViewWithDataTableList = true;
                }
            }
            catch
            {
            }
        }

        private void gridGroupingControl1_TableControlDrawCell(object sender, GridTableControlDrawCellEventArgs e)
        {
            try
            {
                GridTableCellStyleInfo style = e.Inner.Style as GridTableCellStyleInfo;
                if (style.TableCellIdentity.TableCellType == GridTableCellType.TopLeftHeaderCell)
                {
                    e.Inner.Cancel = true;
                    Rectangle ImageRect = new Rectangle(e.Inner.Bounds.Location, new Size(40, e.Inner.Bounds.Height));
                    Rectangle TextRect = new Rectangle(new Point(e.Inner.Bounds.Location.X + 40, e.Inner.Bounds.Location.Y),
                    new Size(e.Inner.Bounds.Size.Width - 10, e.Inner.Bounds.Height));
                }
            }
            catch
            {
            }
        }

        private void gridGroupingControl1_TableControlCellClick(object sender, GridTableControlCellClickEventArgs e)
        {
            try
            {
                this.gidGroupingControl1.Table.SelectedRecords.Clear();
                int currentRow = gidGroupingControl1.TableControl.CurrentCell.RowIndex - 2;// -4;

                if (currentRow > -1)
                {
                    this.gidGroupingControl1.Table.SelectedRecords.Clear();
                    Record rec = this.gidGroupingControl1.Table.Records[currentRow];
                    int assetId = Convert.ToInt32(rec.GetValue("ID"));
                    
                    this.gidGroupingControl1.Table.SelectedRecords.Add(rec);
                }
                
            }
            catch
            {
            }
        }

        void gridGroupingControl1_TableControlCellMouseDown(object sender, GridTableControlCellMouseEventArgs e)
        {
            try
            {
                GridTableCellStyleInfo style = e.TableControl.Table.TableModel[e.Inner.RowIndex, e.Inner.ColIndex];
                if (style.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell)
                {
                    if (e.Inner.MouseEventArgs.Button == MouseButtons.Right)
                    {
                        //menu.Show(this.gridGroupingControl1, e.Inner.MouseEventArgs.Location);
                        //e.Inner.Cancel = true;

                        //if (style.TableCellIdentity.TableCellType == GridTableCellType.TopLeftHeaderCell)
                        //{
                        //this.cmsColumnHeaders.Show(this.gridGroupingControl1, e.Inner.MouseEventArgs.X, e.Inner.MouseEventArgs.Y);
                        //}
                    }
                }
            }
            catch
            { }
        }

        private void GridSorting()
        {
            try
            {
                if (this.gidGroupingControl1.Engine.TableDescriptor.SortedColumns.Contains("ID"))
                    this.gidGroupingControl1.Engine.TableDescriptor.SortedColumns.Clear();
                this.gidGroupingControl1.Engine.TableDescriptor.SortedColumns.Add("ID", ListSortDirection.Ascending);
            }
            catch
            { }
        }

        private void gridGroupingControl1_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
        {
            try
            {
                Element el = e.TableCellIdentity.DisplayElement;
                if (el.Kind == DisplayElementKind.Record && e.TableCellIdentity.Column != null &&
                (e.TableCellIdentity.Column.Name == "ID" || e.TableCellIdentity.Column.Name == "ID1"))
                {
                    e.Style.ReadOnly = false;

                }
                else
                {
                    e.Style.ReadOnly = true;
                    
                }
            }
            catch
            { }

        }
        private void gridGroupingControl1_TableControlQueryAllowSortColumn(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridQueryAllowSortColumnEventArgs e)
        {
            if (e.Column.GetName() == "ID")
            {
                e.AllowSort = true;

            }
            else
            {
                e.AllowSort = false;
            }
        }

        private void GridEvents()
        {
            this.gidGroupingControl1.TableControlCellClick += new GridTableControlCellClickEventHandler(gridGroupingControl1_TableControlCellClick);
            this.gidGroupingControl1.TableControlDrawCell += new GridTableControlDrawCellEventHandler(gridGroupingControl1_TableControlDrawCell);
            //this.gridGroupingControl1.TableControlCurrentCellChanged += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlEventHandler(this.gridGroupingControl1_TableControlCurrentCellChanged);
            this.gidGroupingControl1.TableControlCellMouseDown += new GridTableControlCellMouseEventHandler(gridGroupingControl1_TableControlCellMouseDown);
            this.gidGroupingControl1.QueryCellStyleInfo += new GridTableCellStyleInfoEventHandler(gridGroupingControl1_QueryCellStyleInfo);
            this.gidGroupingControl1.TableControlQueryAllowSortColumn += new Syncfusion.Windows.Forms.Grid.Grouping.GridQueryAllowSortColumnEventHandler(gridGroupingControl1_TableControlQueryAllowSortColumn);
            //this.gridGroupingControl1.TableControlCurrentCellStartEditing += new GridTableControlCancelEventHandler(gridGroupingControl1_TableControlCurrentCellStartEditing);
            this.gidGroupingControl1.TableControlCurrentCellKeyUp += new GridTableControlKeyEventHandler(gridGroupingControl1_TableControlCurrentCellKeyUp);
            //this.gridGroupingControl1.TableControlCurrentCellEditingComplete += new GridTableControlEventHandler(gridGroupingControl1_TableControlCurrentCellEditingComplete);
            //this.gridGroupingControl1.TableControlCurrentCellShowingDropDown += new GridTableControlCurrentCellShowingDropDownEventHandler(gridGroupingControl1_TableControlCurrentCellShowingDropDown);
            this.gidGroupingControl1.TableControlCurrentCellCloseDropDown += new GridTableControlPopupClosedEventHandler(gridGroupingControl1_TableControlCurrentCellCloseDropDown);
            //this.gridGroupingControl1.TableControlPrepareViewStyleInfo+=new GridTableControlPrepareViewStyleInfoEventHandler(gridGroupingControl1_TableControlPrepareViewStyleInfo);

        }

        void gridGroupingControl1_TableControlCurrentCellCloseDropDown(object sender, GridTableControlPopupClosedEventArgs e)
        {
            try
            {
                GridCurrentCell cc = e.TableControl.CurrentCell;
                GridTableCellStyleInfoIdentity style = gidGroupingControl1.TableModel[cc.RowIndex, cc.ColIndex].TableCellIdentity;
                if (style.Column.Name.Trim() == "ID")
                {
                    //CellEditingSetUp(false);
                }
            }
            catch
            { }
        }

        private void gridGroupingControl1_TableControlCurrentCellKeyUp(object sender, GridTableControlKeyEventArgs e)
        {
            try
            {
                //if (!CellEditing) return;
                GridCurrentCell cc = e.TableControl.CurrentCell;
                GridTableCellStyleInfoIdentity style = gidGroupingControl1.TableModel[cc.RowIndex, cc.ColIndex].TableCellIdentity;
                if (style.Column.Name.Trim() == "ID")
                {
                    //UserIdleTimer.Enabled = false;
                    //UserIdleTimer.Enabled = true;
                }
            }
            catch
            { }
        }

        private void gidGroupingControl1_TableControlCurrentCellActivating(object sender, GridTableControlCurrentCellActivatingEventArgs e)
        {
           
        }

        private void gidGroupingControl1_TableControlCurrentCellActivated(object sender, GridTableControlEventArgs e)
        {
            if (blinkDescriptor != null)
            {
                bool _bIsBinkColor = blinkDescriptor.CompareRecord(e.TableControl.Table.CurrentRecord);
                if (_bIsBinkColor)
                    this.gidGroupingControl1.TableOptions.SelectionBackColor = blinkDescriptor.Appearance.AnyRecordFieldCell.BackColor;
                else
                    this.gidGroupingControl1.TableOptions.SelectionBackColor = SystemColors.Control; 
            }
        }
    }
      
        public class CustomClass : INotifyPropertyChanged
        {
            int id;
            string first_name;
            string last_name;
            string address;
            string city;
            int id1;
            int id2;
            int id3;
            int id4;
            int id5;
            int id6;
            int id7;
            int id8;
            public CustomClass(int id, string fname, string lname, string addr, string city, int a,int b, int c, int d, int e, int f, int g, int h)
            {
                this.id = id;
                first_name = fname;
                last_name = lname;
                address = addr;
                this.city = city;
                id1 =a;
                id2 =b;
                id3=c;
                id4=d;

                id5 =e;
                id6 =f;

                id7 =g;
                id8 = h;

                
            }


            // ############################
            public int ID1
            {
                get { return id1; }
                set
                {
                    if (id1 != value)
                    {
                        id1 = value;
                        RaisePropertyChanged("ID1");
                    }
                }
            }

            public int ID2
            {
                get { return id2; }
                set
                {
                    if (id2 != value)
                    {
                        id2 = value;
                        RaisePropertyChanged("ID2");
                    }
                }
            }

            public int ID3
            {
                get { return id3; }
                set
                {
                    if (id3!= value)
                    {
                        id3 = value;
                        RaisePropertyChanged("ID3");
                    }
                }
            }

            public int ID4
            {
                get { return id4; }
                set
                {
                    if (id4 != value)
                    {
                        id4 = value;
                        RaisePropertyChanged("ID4");
                    }
                }
            }

            public int ID5
            {
                get { return id5; }
                set
                {
                    if (id5 != value)
                    {
                        id5 = value;
                        RaisePropertyChanged("ID5");
                    }
                }
            }

            public int ID6
            {
                get { return id6; }
                set
                {
                    if (id6 != value)
                    {
                        id6 = value;
                        RaisePropertyChanged("ID6");
                    }
                }
            }

            public int ID7
            {
                get { return id7; }
                set
                {
                    if (id7 != value)
                    {
                        id7 = value;
                        RaisePropertyChanged("ID7");
                    }
                }
            }

            public int ID8
            {
                get { return id8; }
                set
                {
                    if (id8 != value)
                    {
                        id8= value;
                        RaisePropertyChanged("ID8");
                    }
                }
            }




            public int ID
            {
                get { return id; }
                set
                {
                    if (id != value)
                    {
                        id = value;
                        RaisePropertyChanged("ID");
                    }
                }
            }

            public string FirstName
            {
                get { return first_name; }
                set
                {
                    if (first_name != value)
                    {
                        first_name = value;
                        RaisePropertyChanged("FirstName");
                    }
                }
            }
            public string LastName
            {
                get { return last_name; }
                set
                {
                    if (last_name != value)
                    {
                        last_name = value;
                        RaisePropertyChanged("LastName");
                    }
                    last_name = value;
                }
            }
            public string Address
            {
                get { return address; }
                set
                {
                    if (address != value)
                    {
                        address = value;
                        RaisePropertyChanged("Address");
                    }
                }
            }
            public string City
            {
                get { return city; }
                set
                {
                    if (city != value)
                    {
                        city = value;
                        RaisePropertyChanged("City");
                    }
                }
            }

            void RaisePropertyChanged(string name)
            {
                if (PropertyChanged != null)
                    PropertyChanged(this, new PropertyChangedEventArgs(name));
            }



            #region INotifyPropertyChanged Members

            public event PropertyChangedEventHandler PropertyChanged;


        }



            #endregion
    }
